"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  default: () => FormDSFR,
  templatesDSFR: () => templatesDSFR,
  widgetsDSFR: () => widgetsDSFR
});
module.exports = __toCommonJS(src_exports);
var import_core = __toESM(require("@rjsf/core"), 1);
var import_validator_ajv8 = __toESM(require("@rjsf/validator-ajv8"), 1);
var import_Button2 = require("@codegouvfr/react-dsfr/Button");

// src/components/WidgetCheckBox.tsx
var import_Checkbox = __toESM(require("@codegouvfr/react-dsfr/Checkbox"), 1);

// src/components/LabelWithHelp.tsx
var import_react_dsfr = require("@codegouvfr/react-dsfr");
var import_react = require("react");
var import_jsx_runtime = require("react/jsx-runtime");
function LabelWithHelp({
  helpText,
  children,
  as = "span",
  ...rest
}) {
  const [showHelp, setShowHelp] = (0, import_react.useState)(false);
  const Content = as;
  if (children == void 0) {
    return null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "flex flex-col ", children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "flex", style: { alignItems: "center" }, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(Content, { ...rest, children: [
      children,
      helpText ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "i",
        {
          style: { cursor: "pointer" },
          className: import_react_dsfr.fr.cx(
            "fr-icon--sm",
            "fr-ml-1w",
            !showHelp ? "fr-icon-information-line" : "fr-icon-information-fill"
          ),
          onClick: () => setShowHelp(!showHelp)
        }
      ) : null
    ] }) }),
    showHelp ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)("p", { className: "fr-hint-text", children: helpText }) : null
  ] });
}

// src/components/WidgetCheckBox.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
function WidgetCheckBox_default(props) {
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { style: { marginTop: "1rem", marginBottom: "-1rem" }, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    import_Checkbox.default,
    {
      options: [
        {
          label: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            LabelWithHelp,
            {
              helpText: props.uiSchema !== void 0 ? props.uiSchema["ui:help"] : void 0,
              children: props.schema.title + (props.required ? "*" : "")
            }
          ),
          nativeInputProps: {
            checked: props.value,
            onChange: (e) => props.onChange(e.target.checked)
          }
        }
      ]
    }
  ) });
}

// src/components/WidgetRadio.tsx
var import_utils = require("@rjsf/utils");
var import_RadioButtons = __toESM(require("@codegouvfr/react-dsfr/RadioButtons"), 1);
var import_jsx_runtime3 = require("react/jsx-runtime");
function RadioWidget({
  id,
  options,
  value,
  required,
  disabled,
  readonly,
  onChange,
  onBlur,
  onFocus,
  uiSchema,
  schema
}) {
  const { enumOptions, enumDisabled, emptyValue } = options;
  const _onChange = ({ target: { value: value2 } }) => onChange((0, import_utils.enumOptionsValueForIndex)(value2, enumOptions, emptyValue));
  const _onBlur = ({ target: { value: value2 } }) => onBlur(id, (0, import_utils.enumOptionsValueForIndex)(value2, enumOptions, emptyValue));
  const _onFocus = ({ target: { value: value2 } }) => onFocus(id, (0, import_utils.enumOptionsValueForIndex)(value2, enumOptions, emptyValue));
  const inline = Boolean(options && options.inline);
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { style: { marginTop: "1rem", marginBottom: "-1rem" }, children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
    import_RadioButtons.default,
    {
      options: options && options.enumOptions?.map((option) => ({
        label: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
          LabelWithHelp,
          {
            helpText: uiSchema !== void 0 ? uiSchema["ui:help"] : void 0,
            children: option.label
          }
        ),
        nativeInputProps: {
          checked: value === option.value,
          onChange: (e) => onChange(option.value)
        }
      })) || []
    }
  ) });
}

// src/components/WidgetSelect.tsx
var import_Select = __toESM(require("@codegouvfr/react-dsfr/Select"), 1);
var import_utils2 = require("@rjsf/utils");
var import_react2 = require("react");
var import_jsx_runtime4 = require("react/jsx-runtime");
function WidgetSelect_default({
  label,
  rawErrors,
  autofocus,
  readonly,
  formContext,
  hideError,
  hideLabel,
  uiSchema,
  ...props
}) {
  const { enumOptions, emptyValue: optEmptyVal } = props.options;
  const handleChange = (0, import_react2.useCallback)(
    (event) => {
      const newValue = getValue(event, props.multiple ?? false);
      return props.onChange(
        (0, import_utils2.enumOptionsValueForIndex)(
          newValue,
          enumOptions,
          optEmptyVal
        )
      );
    },
    [props.onChange, props.schema, props.multiple, props.options]
  );
  const selectedIndexes = (0, import_utils2.enumOptionsIndexForValue)(
    props.value,
    props.options.enumOptions,
    props.multiple
  );
  const defaultIndex = (0, import_utils2.enumOptionsIndexForValue)(
    props.schema.default,
    props.options.enumOptions,
    props.multiple
  );
  const value = typeof selectedIndexes === "undefined" ? defaultIndex : selectedIndexes;
  const uiOptions = (0, import_utils2.getUiOptions)(uiSchema);
  const backgroundColor = uiOptions.backgroundColor || "auto";
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)(
    import_Select.default,
    {
      nativeSelectProps: {
        id: props.id,
        name: props.name,
        required: props.required,
        value,
        onChange: handleChange,
        style: { backgroundColor }
      },
      label: void 0,
      ...props,
      children: [
        !props.multiple && props.schema.default === void 0 && props.options.placeholder && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("option", { value: "", disabled: true, children: props.options.placeholder }),
        props.options.enumOptions?.map((item, index) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("option", { value: String(index), children: item.label }, index)),
        "state=",
        rawErrors && rawErrors.length ? "error" : "default",
        "stateRelatedMessage=",
        rawErrors?.length && rawErrors[0]
      ]
    }
  );
}
function getValue(event, multiple) {
  if (multiple) {
    return Array.from(event.target.options).slice().filter((o) => o.selected).map((o) => o.value);
  }
  return event.target.value;
}

// src/components/WidgetTextarea.tsx
var import_utils3 = require("@rjsf/utils");
var import_Input = __toESM(require("@codegouvfr/react-dsfr/Input"), 1);
var import_jsx_runtime5 = require("react/jsx-runtime");
function WidgetTextarea({
  id,
  placeholder,
  value,
  required,
  type,
  uiSchema,
  label,
  disabled,
  autofocus,
  readonly,
  hideError,
  formContext,
  rawErrors,
  options,
  onBlur,
  onFocus,
  onChange,
  ...rest
}) {
  const uiOptions = (0, import_utils3.getUiOptions)(uiSchema);
  const rows = uiOptions.rows || 3;
  const backgroundColor = uiOptions.backgroundColor || "auto";
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
    import_Input.default,
    {
      textArea: true,
      nativeTextAreaProps: {
        rows,
        required,
        placeholder,
        autoFocus: autofocus,
        readOnly: readonly,
        value,
        onChange: (e) => onChange(e.target.value),
        style: { backgroundColor }
      },
      state: rawErrors && rawErrors.length ? "error" : "default",
      stateRelatedMessage: rawErrors?.length && rawErrors[0],
      disabled,
      label: void 0,
      ...rest
    }
  );
}

// src/components/TemplateArrayField.tsx
var import_Button = __toESM(require("@codegouvfr/react-dsfr/Button"), 1);
var import_Tabs = __toESM(require("@codegouvfr/react-dsfr/Tabs"), 1);
var import_jsx_runtime6 = require("react/jsx-runtime");
function TemplateArrayField_default({
  title,
  uiSchema,
  items,
  canAdd,
  onAddClick
}) {
  const tabLabel = uiSchema?.["ui:tabLabel"] ?? "Element";
  const removeIcon = uiSchema?.["ui:removeIcon"] ?? "fr-icon-delete-line";
  const addIcon = uiSchema?.["ui:addIcon"] ?? "fr-icon-add-circle-line";
  console.log("items", items);
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "form-group field", children: /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "fr-input-group", children: [
    /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("label", { className: "fr-label", children: title }),
    /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "fr-input-wrap", children: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
      import_Tabs.default,
      {
        tabs: items.map((element) => ({
          label: `${tabLabel} ${element.index + 1}`,
          content: /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)(import_jsx_runtime6.Fragment, { children: [
            /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
              import_Button.default,
              {
                type: "button",
                iconId: removeIcon,
                onClick: (e) => {
                  console.log("io", element);
                  element.onDropIndexClick(element.index);
                },
                size: "small",
                priority: "secondary",
                children: "Supprimer"
              }
            ),
            element.children
          ] })
        })).concat([
          {
            label: `Ajouter`,
            content: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_jsx_runtime6.Fragment, { children: canAdd && /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
              import_Button.default,
              {
                type: "button",
                iconId: addIcon,
                onClick: onAddClick,
                size: "small",
                priority: "secondary",
                children: "Ajouter"
              }
            ) })
          }
        ])
      }
    ) })
  ] }) });
}

// src/components/TemplateBaseInput.tsx
var import_Input2 = __toESM(require("@codegouvfr/react-dsfr/Input"), 1);
var import_utils4 = require("@rjsf/utils");
var import_jsx_runtime7 = require("react/jsx-runtime");
function TemplateBaseInput_default({
  id,
  placeholder,
  value,
  required,
  type,
  uiSchema,
  label,
  disabled,
  autofocus,
  readonly,
  hideError,
  formContext,
  rawErrors,
  options,
  onBlur,
  onFocus,
  onChange,
  ...rest
}) {
  if (type === "date") {
    value = uiSchema && uiSchema["ui:currentDate"] ? value ?? (/* @__PURE__ */ new Date()).toISOString().split("T")[0] : value;
    onChange(value);
  }
  const uiOptions = (0, import_utils4.getUiOptions)(uiSchema);
  const inputType = uiOptions.inputType || type;
  const backgroundColor = uiOptions.backgroundColor || "auto";
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
    import_Input2.default,
    {
      disabled,
      nativeInputProps: {
        type: inputType,
        required,
        placeholder,
        autoFocus: autofocus,
        readOnly: readonly,
        value,
        onChange: (e) => onChange(e.target.value),
        min: rest.schema.minimum,
        style: { backgroundColor }
      },
      state: rawErrors && rawErrors.length ? "error" : "default",
      stateRelatedMessage: rawErrors?.length && rawErrors[0],
      label: void 0,
      ...rest
    }
  );
}

// src/components/TemplateField.tsx
var import_jsx_runtime8 = require("react/jsx-runtime");
var schemaTypesToNotRenderTitles = ["boolean", "array"];
function TemplateField_default({
  classNames,
  style,
  errors,
  children,
  id,
  required,
  label,
  schema,
  uiSchema
}) {
  let title = null;
  let heading = uiSchema && uiSchema["ui:heading"];
  if (heading != void 0) {
    switch (heading) {
      case "h3":
        title = /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("h3", { className: "fr-h3", children: label });
        break;
      case "h4":
        title = /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("h4", { className: "fr-h4", children: label });
        break;
      case "h5":
        title = /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("h5", { className: "fr-h5", children: label });
        break;
      case "h6":
        title = /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("h6", { className: "fr-h6", children: label });
        break;
      default:
        title = /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("h2", { className: "fr-h2", children: label });
        break;
    }
  } else {
    title = !schemaTypesToNotRenderTitles.includes(schema.type) ? !uiSchema || !uiSchema["ui:hideTitle"] ? /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(
      LabelWithHelp,
      {
        helpText: uiSchema ? uiSchema["ui:help"] : void 0,
        as: "label",
        htmlFor: id,
        className: "fr-label",
        children: label + (required ? " (obligatoire)" : "")
      }
    ) : null : null;
  }
  const description = uiSchema && uiSchema["ui:description"];
  return /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)("div", { className: classNames + " fr-mt-1w", style, children: [
    title,
    description && /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("p", { className: "fr-hint-text", children: description }),
    children
  ] });
}

// src/components/TemplateTitleField.tsx
function TemplateTitleField_default(_) {
  return null;
}

// src/components/ErrorList.tsx
var import_Alert = __toESM(require("@codegouvfr/react-dsfr/Alert"), 1);
var import_jsx_runtime9 = require("react/jsx-runtime");
function ErrorList({ errors, registry }) {
  const { translateString } = registry;
  return /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(
    import_Alert.default,
    {
      severity: "error",
      title: "Erreurs",
      description: /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("ul", { children: errors.map((error, i) => {
        return /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("li", { className: "border-0", children: /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("span", { children: error.stack }) }, i);
      }) })
    }
  );
}

// src/index.tsx
var import_jsx_runtime10 = require("react/jsx-runtime");
function FormDSFR({ widgets, templates, validator, ...rest }) {
  return /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(
    import_core.default,
    {
      validator: validator ?? import_validator_ajv8.default,
      widgets: widgets !== void 0 ? {
        ...widgetsDSFR,
        ...widgets
      } : widgetsDSFR,
      templates: templates !== void 0 ? {
        ...templatesDSFR,
        ...templates
      } : templatesDSFR,
      ...rest
    }
  );
}
var widgetsDSFR = {
  CheckboxWidget: WidgetCheckBox_default,
  RadioWidget,
  SelectWidget: WidgetSelect_default,
  TextareaWidget: WidgetTextarea
};
var templatesDSFR = {
  ArrayFieldTemplate: TemplateArrayField_default,
  BaseInputTemplate: TemplateBaseInput_default,
  FieldTemplate: TemplateField_default,
  ButtonTemplates: { SubmitButton },
  TitleFieldTemplate: TemplateTitleField_default,
  ErrorListTemplate: ErrorList
};
function SubmitButton({ uiSchema }) {
  const buttonOptions = uiSchema?.["ui:options"]?.submitButtonOptions;
  const buttonProps = uiSchema?.["ui:options"]?.submitButtonOptions?.props || {};
  return (
    // NOTE: should the div stay here? Probably not.
    /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("div", { className: "flex w-full fr-mt-2w", children: /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_Button2.Button, { ...buttonProps, children: buttonOptions?.submitText ?? "Envoyer" }) })
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  templatesDSFR,
  widgetsDSFR
});
//# sourceMappingURL=index.cjs.map